import { R as Reference, A as AstNode } from './AstNode-C4zH8AqA.cjs';
import { Writer } from './core/Writer.cjs';
import { Decorator } from './Decorator.cjs';
import { Field } from './Field.cjs';
import '@fern-api/generator-commons';
import './core/types.cjs';
import './Type.cjs';

declare namespace Class {
    interface Args {
        name: string;
        docs?: string;
        extends_?: Reference[];
        decorators?: Decorator[];
    }
}
declare class Class extends AstNode {
    readonly name: string;
    readonly extends_: Reference[];
    readonly decorators: Decorator[];
    readonly fields: Field[];
    readonly docs?: string;
    private statements;
    constructor({ docs, name, extends_, decorators }: Class.Args);
    write(writer: Writer): void;
    add(statement: AstNode): void;
    private writeStatements;
    addField(field: Field): void;
}

export { Class };
