import { A as AstNode } from './AstNode-C4zH8AqA.cjs';
import { Writer } from './core/Writer.cjs';
import { Type } from './Type.cjs';
import '@fern-api/generator-commons';
import './core/types.cjs';

declare namespace Field {
    interface BaseArgs {
        name: string;
        docs?: string;
    }
    type Args = BaseArgs & ({
        type: Type;
        initializer?: AstNode;
    } | {
        type?: Type;
        initializer: AstNode;
    } | {
        type: Type;
        initializer: AstNode;
    });
}
declare class Field extends AstNode {
    readonly name: string;
    readonly type: Type | undefined;
    readonly initializer: AstNode | undefined;
    readonly docs: string | undefined;
    constructor({ name, type, initializer, docs }: Field.Args);
    write(writer: Writer): void;
}

export { Field };
