import { A as AstNode } from './AstNode-C4zH8AqA.cjs';
import { Writer } from './core/Writer.cjs';
import { Type } from './Type.cjs';
import { Parameter } from './Parameter.cjs';
import { Decorator } from './Decorator.cjs';
import '@fern-api/generator-commons';
import './core/types.cjs';
import './CodeBlock.cjs';

declare enum ClassMethodType {
    STATIC = 0,
    INSTANCE = 1,
    CLASS = 2
}
declare namespace Method {
    interface Args {
        name: string;
        parameters?: Parameter[];
        return_?: Type;
        docstring?: string;
        type?: ClassMethodType;
        static_?: boolean;
        decorators?: Decorator[];
    }
}
declare class Method extends AstNode {
    readonly name: string;
    readonly return: Type | undefined;
    readonly docstring: string | undefined;
    readonly type: ClassMethodType | undefined;
    private readonly parameters;
    private readonly decorators;
    private readonly statements;
    private readonly static_;
    constructor({ static_, name, parameters, return_, docstring, type, decorators }: Method.Args);
    addStatement(statement: AstNode): void;
    write(writer: Writer): void;
}

export { ClassMethodType, Method };
