"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Parameter.ts
var Parameter_exports = {};
__export(Parameter_exports, {
  Parameter: () => Parameter
});
module.exports = __toCommonJS(Parameter_exports);

// src/core/AstNode.ts
var import_generator_commons2 = require("@fern-api/generator-commons");

// src/core/Writer.ts
var import_generator_commons = require("@fern-api/generator-commons");
var Writer = class extends import_generator_commons.AbstractWriter {
  toString() {
    return this.buffer;
  }
  async toStringFormatted() {
    const { default: init, format } = await import("@wasm-fmt/ruff_fmt");
    await init();
    return format(this.buffer);
  }
};

// src/core/AstNode.ts
var AstNode = class extends import_generator_commons2.AbstractAstNode {
  references = [];
  addReference(reference) {
    this.references.push(reference);
  }
  inheritReferences(astNode) {
    if (astNode === void 0) {
      return;
    }
    astNode.references.forEach((reference) => {
      if (!this.references.includes(reference)) {
        this.addReference(reference);
      }
    });
  }
  getReferences() {
    return this.references;
  }
  /**
   * Writes the node to a string.
   */
  toString() {
    const writer = new Writer();
    this.write(writer);
    return writer.toString();
  }
  /**
   * Writes the node to a string and formats it.
   */
  async toStringFormatted() {
    const writer = new Writer();
    this.write(writer);
    return await writer.toStringFormatted();
  }
};

// src/Parameter.ts
var Parameter = class extends AstNode {
  name;
  initializer;
  type;
  constructor({ name, type, initializer }) {
    super();
    this.name = name;
    this.type = type;
    this.initializer = initializer;
  }
  write(writer) {
    writer.write(this.name);
    writer.write(": ");
    this.type.write(writer);
    if (this.initializer !== void 0) {
      writer.write(" = ");
      this.initializer.write(writer);
    }
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Parameter
});
