import { CodeBlock } from './CodeBlock.cjs';
import { A as AstNode } from './AstNode-C4zH8AqA.cjs';
import { Writer } from './core/Writer.cjs';
import { Type } from './Type.cjs';
import '@fern-api/generator-commons';
import './core/types.cjs';

declare namespace Parameter {
    interface Args {
        name: string;
        type: Type;
        initializer?: CodeBlock;
    }
}
declare class Parameter extends AstNode {
    readonly name: string;
    readonly initializer: CodeBlock | undefined;
    readonly type: Type;
    constructor({ name, type, initializer }: Parameter.Args);
    write(writer: Writer): void;
}

export { Parameter };
