"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Reference.ts
var Reference_exports = {};
__export(Reference_exports, {
  Reference: () => Reference
});
module.exports = __toCommonJS(Reference_exports);

// src/core/AstNode.ts
var import_generator_commons2 = require("@fern-api/generator-commons");

// src/core/Writer.ts
var import_generator_commons = require("@fern-api/generator-commons");
var Writer = class extends import_generator_commons.AbstractWriter {
  toString() {
    return this.buffer;
  }
  async toStringFormatted() {
    const { default: init, format } = await import("@wasm-fmt/ruff_fmt");
    await init();
    return format(this.buffer);
  }
};

// src/core/AstNode.ts
var AstNode = class extends import_generator_commons2.AbstractAstNode {
  references = [];
  addReference(reference) {
    this.references.push(reference);
  }
  inheritReferences(astNode) {
    if (astNode === void 0) {
      return;
    }
    astNode.references.forEach((reference) => {
      if (!this.references.includes(reference)) {
        this.addReference(reference);
      }
    });
  }
  getReferences() {
    return this.references;
  }
  /**
   * Writes the node to a string.
   */
  toString() {
    const writer = new Writer();
    this.write(writer);
    return writer.toString();
  }
  /**
   * Writes the node to a string and formats it.
   */
  async toStringFormatted() {
    const writer = new Writer();
    this.write(writer);
    return await writer.toStringFormatted();
  }
};

// src/Reference.ts
var Reference = class extends AstNode {
  name;
  modulePath;
  genericTypes;
  alias;
  attribute;
  constructor({ name, modulePath, genericTypes, alias, attribute }) {
    super();
    this.name = name;
    this.modulePath = modulePath ?? [];
    this.genericTypes = genericTypes ?? [];
    this.alias = alias;
    this.attribute = attribute ?? [];
    this.references.push(this);
    this.genericTypes.forEach((genericType) => {
      this.inheritReferences(genericType);
    });
  }
  write(writer) {
    writer.write(this.alias ?? this.name);
    if (this.genericTypes.length > 0) {
      writer.write("[");
      this.genericTypes.forEach((genericType, index) => {
        if (index > 0) {
          writer.write(", ");
        }
        genericType.write(writer);
      });
      writer.write("]");
    }
    if (this.attribute.length > 0) {
      writer.write(".");
      this.attribute.forEach((attr, index) => {
        if (index > 0) {
          writer.write(".");
        }
        writer.write(attr);
      });
    }
  }
  getFullyQualifiedModulePath() {
    return this.modulePath.join(".");
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Reference
});
