import { Class } from './Class.cjs';
import { Field } from './Field.cjs';
import { R as Reference } from './AstNode-C4zH8AqA.cjs';
import { CodeBlock } from './CodeBlock.cjs';
import { Method } from './Method.cjs';
import { MethodInvocation } from './MethodInvocation.cjs';
import { ClassInstantiation } from './ClassInstantiation.cjs';
import { Parameter } from './Parameter.cjs';
import { MethodArgument } from './MethodArgument.cjs';
import { PythonFile } from './PythonFile.cjs';
import { Decorator } from './Decorator.cjs';
import { Operator } from './Operator.cjs';
import { Type } from './Type.cjs';
import { TypeInstantiation } from './TypeInstantiation.cjs';
import './core/Writer.cjs';
import '@fern-api/generator-commons';
import './core/types.cjs';
import './BaseInvocation.cjs';
import './OperatorType.cjs';

declare function file(args: PythonFile.Args): PythonFile;
declare function class_(args: Class.Args): Class;
declare function instantiateClass(args: ClassInstantiation.Args): ClassInstantiation;
declare function decorator(args: Decorator.Args): Decorator;
declare function reference(args: Reference.Args): Reference;
declare function field(args: Field.Args): Field;
declare function codeBlock(args: CodeBlock.Arg): CodeBlock;
declare function method(args: Method.Args): Method;
declare function invokeMethod(args: MethodInvocation.Args): MethodInvocation;
declare function parameter(args: Parameter.Args): Parameter;
declare function methodArgument(args: MethodArgument.Args): MethodArgument;
declare function operator(args: Operator.Args): Operator;

declare const python_Class: typeof Class;
declare const python_ClassInstantiation: typeof ClassInstantiation;
declare const python_CodeBlock: typeof CodeBlock;
declare const python_Decorator: typeof Decorator;
declare const python_Field: typeof Field;
declare const python_Method: typeof Method;
declare const python_MethodArgument: typeof MethodArgument;
declare const python_MethodInvocation: typeof MethodInvocation;
declare const python_Operator: typeof Operator;
declare const python_Parameter: typeof Parameter;
declare const python_PythonFile: typeof PythonFile;
declare const python_Reference: typeof Reference;
declare const python_Type: typeof Type;
declare const python_TypeInstantiation: typeof TypeInstantiation;
declare const python_class_: typeof class_;
declare const python_codeBlock: typeof codeBlock;
declare const python_decorator: typeof decorator;
declare const python_field: typeof field;
declare const python_file: typeof file;
declare const python_instantiateClass: typeof instantiateClass;
declare const python_invokeMethod: typeof invokeMethod;
declare const python_method: typeof method;
declare const python_methodArgument: typeof methodArgument;
declare const python_operator: typeof operator;
declare const python_parameter: typeof parameter;
declare const python_reference: typeof reference;
declare namespace python {
  export { python_Class as Class, python_ClassInstantiation as ClassInstantiation, python_CodeBlock as CodeBlock, python_Decorator as Decorator, python_Field as Field, python_Method as Method, python_MethodArgument as MethodArgument, python_MethodInvocation as MethodInvocation, python_Operator as Operator, python_Parameter as Parameter, python_PythonFile as PythonFile, python_Reference as Reference, python_Type as Type, python_TypeInstantiation as TypeInstantiation, python_class_ as class_, python_codeBlock as codeBlock, python_decorator as decorator, python_field as field, python_file as file, python_instantiateClass as instantiateClass, python_invokeMethod as invokeMethod, python_method as method, python_methodArgument as methodArgument, python_operator as operator, python_parameter as parameter, python_reference as reference };
}

export { Class, ClassInstantiation, CodeBlock, Decorator, Field, Method, MethodArgument, MethodInvocation, Operator, Parameter, PythonFile, Reference, Type, TypeInstantiation, class_, codeBlock, decorator, field, file, instantiateClass, invokeMethod, method, methodArgument, operator, python as p, parameter, reference };
